Index: /trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- /trunk/SophyaPI/PIext/nobjmgr.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/nobjmgr.cc	(revision 333)
@@ -22,7 +22,4 @@
 #include "pistdimgapp.h"
 
-#include "matrix.h"
-#include "cvector.h"
-#include "ntuple.h"
 
 // EVOL-PLANCK
@@ -31,12 +28,7 @@
 #endif
 
-#include "fct1dfit.h"
-#include "fct2dfit.h"
-
 #include "pisurfdr.h"
 #include "pipodrw.h"
-#include "pihisto.h"
-#include "hisprof.h"
-#include "pihisto2d.h"
+
 #include "pintuple.h"
 #include "pintup3d.h"
@@ -75,5 +67,5 @@
   AnyDataObj* obj;
   NObjMgrAdapter* obja;
-  int num;
+  int oid;
   int dirid;
   list<int> wrsid;
@@ -95,4 +87,10 @@
 
 static string* TmpDir;  // Repertoire pour les compilations / link dynamique
+
+// Pour completer le nom de l'objet avec le nom du repertoire
+static void RemoveSpacesFromName(string & nom);
+static bool CheckDirName(string & nom);
+static int  ParseObjectName(string & nom, string & nomrep, string & nomobj);
+// ..................................................................
 
 //++
@@ -111,7 +109,18 @@
 {
 if (fgOInit == 0) { 
+  myNObj = 0;
+  myDirId = 0;
   myDirs = new NObjDirList;
   myObjs = new NObjList;  
   currDir = new string("home");
+  string dirn = "home";
+  CreateDir(dirn);
+  dirn = "tmp";
+  CreateDir(dirn);
+  dirn = "old";
+  CreateDir(dirn);
+  dirn = "home";
+  SetCurrentDir(dirn);
+  myDirId = 50;
   char* varenv;
   TmpDir = new string("");
@@ -120,5 +129,5 @@
   int l = (*TmpDir).length();
   if ( (l>0) && ((*TmpDir)[l-1] != '/') )  (*TmpDir) += '/';
-  servnobjm = new Services2NObjMgr(NULL, (*TmpDir));
+  servnobjm = new Services2NObjMgr(this, (*TmpDir));
   }
 fgOInit++;
@@ -148,4 +157,11 @@
 myImgApp = app;
 servnobjm->SetImgApp(app);
+
+NObjDirList::iterator it;
+string cn;
+for(it= myDirs->begin(); it != myDirs->end(); it++) {
+  cn = '/' + (*it).first;
+  (myImgApp->ObjMgrW())->AddDirectory(cn.c_str(), (*it).second.id);
+  }
 }
 
@@ -163,16 +179,101 @@
 
 /* --Methode-- */
-void NamedObjMgr::CreateDir(string const& dirname)
-{
-}
-
-/* --Methode-- */
-void NamedObjMgr::DeleteDir(string const& dirname)
-{
-}
-
-/* --Methode-- */
-void NamedObjMgr::SetCurrentDir(string const& dirname)
-{
+void NamedObjMgr::CreateDir(string & dirname)
+{
+if ( !CheckDirName(dirname) ) {
+  cout << "NamedObjMgr::CreateDir( " << dirname << ") Error - Invalid name !" << endl;
+  return; 
+  }
+NObjDirList::iterator it = myDirs->find(dirname);
+if (it != myDirs->end()) {
+  cout << "NamedObjMgr::CreateDir( " << dirname << ") Error - Existing directory !" << endl;
+  return;
+  }
+myDirId++;
+nobj_diritem di;
+di.id = myDirId;
+di.nobj = 0;
+(*myDirs)[dirname] = di;
+if (myImgApp)  { 
+  string str = '/' + dirname;
+  (myImgApp->ObjMgrW())->AddDirectory(str.c_str(), myDirId);
+  }
+cout << "NamedObjMgr::CreateDir() " << dirname << " Created " << endl;
+}
+
+/* --Methode-- */
+void NamedObjMgr::DeleteDir(string & dirname)
+{
+if ( !CheckDirName(dirname) ) {
+  cout << "NamedObjMgr::DeleteDir( " << dirname << ") Error - Invalid name !" << endl;
+  return; 
+  }
+NObjDirList::iterator it = myDirs->find(dirname);
+if (it == myDirs->end()) {
+  cout << "NamedObjMgr::DeleteDir( " << dirname << ") Error - No such directory !" << endl;
+  return;
+  }
+if ((*it).second.nobj > 0) {
+  cout << "NamedObjMgr::DeleteDir() " << dirname << " not empty ! " << endl;
+  return;
+  }
+if ((*it).second.id < 50) {
+  cout << "NamedObjMgr::DeleteDir() " << dirname << " cannot be deleted ! " << endl;
+  return;
+  }
+
+if (myImgApp)  
+  (myImgApp->ObjMgrW())->DelDirectory((*it).second.id);
+myDirs->erase(it);
+cout << "amedObjMgr::DeleteDir() " << dirname << " deleted " << endl;  
+}
+
+/* --Methode-- */
+void NamedObjMgr::SetCurrentDir(string & dirname)
+{
+if ( !CheckDirName(dirname) ) {
+  cout << "NamedObjMgr::SetCurrentDir( " << dirname << ") Error - Invalid name !" << endl;
+  return; 
+  }
+NObjDirList::iterator it = myDirs->find(dirname);
+if (it == myDirs->end()) {
+  cout << "NamedObjMgr::SetCurrentDir( " << dirname << ") Error - No such directory !" << endl;
+  return;
+  }
+*currDir = dirname;
+cout << "NamedObjMgr::SetCurrentDir() -> " << dirname << endl;
+}
+
+/* --Methode-- */
+void NamedObjMgr::GetCurrentDir(string & dirname)
+{
+dirname = *currDir;
+}
+
+/* --Methode-- */
+void NamedObjMgr::ListDirs(string & patt)
+{
+NObjDirList::iterator it;
+string cn;
+cout << "NamedObjMgr::ListDirs( " << patt << " ) " << endl;
+int k = 0;
+for(it= myDirs->begin(); it != myDirs->end(); it++) {
+  cn = (*it).first;
+  if (csh_parse(cn.c_str(), patt.c_str()) == 0) continue;
+  k++;
+  cout << k << "- " << (*it).first << "  (NbObj= " << (*it).second.nobj << ")" << endl; 
+  }
+}
+
+/* --Methode-- */
+void NamedObjMgr::GetDirList(string & patt, vector<string>& lstd)
+{
+NObjDirList::iterator it;
+string cn;
+for(it= myDirs->begin(); it != myDirs->end(); it++) {
+  cn = (*it).first;
+  if (csh_parse(cn.c_str(), patt.c_str()) == 0) continue;
+  lstd.push_back(cn);
+  }
 }
 
@@ -186,4 +287,5 @@
 {
 }
+
 
 //++
@@ -209,27 +311,48 @@
 
 /* --Methode-- */
-void NamedObjMgr::AddObj(AnyDataObj* obj, string & nom, bool)
+void NamedObjMgr::AddObj(AnyDataObj* obj, string & nom, bool crd)
 {
 
 if (obj == NULL)  return;
-// on supprime les blancs de debut et de fin 
-size_t p = nom.find_first_not_of(" ");
-if(p>nom.length()) {
-  nom = "";
-} else {
-  nom = nom.substr(p);
-  p = nom.find_first_of(" ");
-  if(p>nom.length()) p=nom.length();
-  nom = nom.substr(0, p);
-}
+// On verifie si l'objet est deja dans la liste 
+NObjList::iterator it;
+for(it = myObjs->begin(); it != myObjs->end(); it++) {
+  if ((*it).second.obj == obj) {
+    cout << "NamedObjMgr::AddObj() Object already present with name " << (*it).first << endl;
+    return;
+    }
+  }
+string nobj;
+string nrep;
+char buff[32];
+int did = ParseObjectName(nom, nrep, nobj);
+if (did == 0) {
+  if (!crd) {
+    cout << "NamedObjMgr::AddObj() No " << nrep << " Directory " << endl;
+    return;
+    }
+  else { CreateDir(nrep);  did =  myDirId; }
+  }
 
 myNObj++;
-if (nom.length() < 1) nom = typeid(*obj).name();
-NObjList::iterator it = myObjs->find(nom);
+if (nobj.length() < 1) { 
+  sprintf(buff,"O%d", myNObj);
+  nobj = buff;
+  }
+
+nom = '/' + nrep + '/' + nobj;  
+it = myObjs->find(nom);
 if (it != myObjs->end()) { // l'objet existe deja
-  char strg[16];
-  sprintf(strg, "%d", myNObj);
-  string nomnew = nom + strg;
-  RenameObj(nom, nomnew);
+  if (nrep == "tmp") {  // Les objets de /tmp sont jetes
+    cout << "NamedObjMgr::AddObj() - Replacing " << nom << endl;
+    DelObj(nom);
+    }
+  else {  // On met l'ancien objet dans /old
+    string on,od;
+    ParseObjectName((*it).first, od, on); 
+    sprintf(buff, "%d", (*it).second.oid);
+    string nomnew = "/old/" + on + buff;
+    RenameObj(nom, nomnew);
+    }
   }
 
@@ -237,11 +360,11 @@
 no.obj = obj;
 no.obja = servnobjm->GetAdapter(obj);  // L'adaptateur
-no.num =  myNObj;
+no.oid =  myNObj;
+no.dirid = did;
 (*myObjs)[nom] = no;
-if (myImgApp)  { 
-  string str = nom + "    (T= " + typeid(*obj).name() + ")" ;
-  (myImgApp->ObjMgrW())->AddObj(str.c_str(), myNObj+1000);
-}
- 
+
+NObjDirList::iterator itr = myDirs->find(nrep);
+(*itr).second.nobj++;
+
 cout << "NamedObjMgr::AddObj()  Object " << nom << " ( "  
      << typeid(*obj).name() << " ) added (Total= " << myObjs->size() << ")" << endl;  
@@ -252,8 +375,33 @@
 void NamedObjMgr::RenameObj(string & nom, string& nomnew)
 {
-AnyDataObj* obj = GetObj(nom);
-if (obj == NULL) return;
-DelObj(nom, false);
-AddObj(obj, nomnew);
+string n1,r1,n2,r2;
+ParseObjectName(nom, r1, n1);
+int did = ParseObjectName(nomnew, r2, n2);
+if (did == 0) {
+  cout << "NamedObjMgr::RenameObj() Error - No " << r2 << " directory !" << endl;
+  return;
+  }
+nom = '/' + r1 + '/' + n1;
+nomnew = '/' + r2 + '/' + n2;
+NObjList::iterator it1 = myObjs->find(nom);
+if (it1 == myObjs->end()) {
+  cout << "NamedObjMgr::RenameObj() Error -  No " << nom << " object !" << endl;
+  return;
+  }
+NObjList::iterator it2 = myObjs->find(nomnew);
+if (it2 != myObjs->end()) {
+  cout << "NamedObjMgr::RenameObj() Error -  Object " << nomnew << " exist !" << endl;
+  return;
+  }
+
+nobj_item no = (*it1).second;
+no.dirid = did;
+myObjs->erase(it1);
+NObjDirList::iterator itr = myDirs->find(r1);
+(*itr).second.nobj--;
+(*myObjs)[nomnew] = no;
+itr = myDirs->find(r2);
+(*itr).second.nobj++;
+cout << "NamedObjMgr::RenameObj() - Object " << nom << " renamed to " << nomnew << endl;
 return;
 }
@@ -262,4 +410,7 @@
 void NamedObjMgr::DelObj(string & nom, bool fgd)
 {
+string n1,r1;
+ParseObjectName(nom, r1, n1);
+nom = '/' + r1 + '/' + n1;
 NObjList::iterator it = myObjs->find(nom);
 if (it == myObjs->end()) return; 
@@ -269,9 +420,12 @@
   for(ii=(*it).second.wrsid.begin(); ii != (*it).second.wrsid.end(); ii++) 
       myImgApp->DelWRsId((*ii));
-  (myImgApp->ObjMgrW())->DelObj((*it).second.num+1000);
 }
 delete (*it).second.obja;  // destruction de l'adaptateur 
 if (fgd) delete (*it).second.obj;
+
 myObjs->erase(it);
+NObjDirList::iterator itr = myDirs->find(r1);
+(*itr).second.nobj--;
+
 if (fgd) cout << "NamedObjMgr::DelObj()  Object " << nom << " deleted (Total= " << myObjs->size() << ")" << endl;
 else  cout << "NamedObjMgr::DelObj()  Object " << nom << " removed (Total= " << myObjs->size() << ")" << endl;
@@ -282,4 +436,13 @@
 void NamedObjMgr::DelObj_Id(int oid)
 {
+NObjList::iterator it;
+string nom;
+bool of = false;
+for(it = myObjs->begin(); it != myObjs->end(); it++) 
+  if ( (*it).second.oid == oid ) { 
+    of = true;  nom = (*it).first;
+    break;
+  }
+if (of) DelObj(nom, true);
 }
 
@@ -287,4 +450,7 @@
 void NamedObjMgr::DelObjects(string & patt, bool fgd)
 {
+string n1,r1;
+ParseObjectName(patt, r1, n1);
+patt = '/' + r1 + '/' + n1;
 NObjList::iterator it;  
 list<string> odel;
@@ -301,4 +467,7 @@
 AnyDataObj* NamedObjMgr::GetObj(string & nom)
 {
+string n1,r1;
+ParseObjectName(nom, r1, n1);
+nom = '/' + r1 + '/' + n1;
 NObjList::iterator it = myObjs->find(nom);
 if (it == myObjs->end()) return(NULL); 
@@ -309,4 +478,7 @@
 NObjMgrAdapter* NamedObjMgr::GetObjAdapter(string & nom)
 {
+string n1,r1;
+ParseObjectName(nom, r1, n1);
+nom = '/' + r1 + '/' + n1;
 NObjList::iterator it = myObjs->find(nom);
 if (it == myObjs->end()) return(NULL); 
@@ -322,9 +494,14 @@
 char strg[256];
 
-cout << "NamedObjMgr::ListObjs() NObjs= " << myObjs->size() << "\n" ;
+string n1,r1;
+ParseObjectName(patt, r1, n1);
+patt = '/' + r1 + '/' + n1;
+ cout << "NamedObjMgr::ListObjs( " << patt << " ) TotNObjs= " << myObjs->size() << "\n" ;
 NObjList::iterator it;  k = 0;
+string cn;
 for(it = myObjs->begin(); it != myObjs->end(); it++) {
+  cn = (*it).first;
+  if (csh_parse(cn.c_str(), patt.c_str()) == 0)  continue;
   obj = (*it).second.obj;
-
   ctyp = typeid(*obj).name();
   sprintf(strg, "%2d/ %16s : %s", k, typeid(*obj).name(), ((*it).first).c_str()); 
@@ -338,6 +515,22 @@
 
 /* --Methode-- */
-void NamedObjMgr::GetObjList(string & patt, vector<string> &)
-{
+void NamedObjMgr::GetObjList(string & patt, vector<string> &lst)
+{
+string n1,r1;
+if (patt.length() < 1)  return;
+bool fgr = (patt[0] == '/') ? true : false;
+ParseObjectName(patt, r1, n1);
+patt = '/' + r1 + '/' + n1;
+NObjList::iterator it;
+string cn;
+for(it = myObjs->begin(); it != myObjs->end(); it++) {
+  cn = (*it).first;
+  if (csh_parse(cn.c_str(), patt.c_str()) == 0)  continue;
+  if (fgr) lst.push_back(cn);
+  else {
+    ParseObjectName(cn, r1, n1);
+    lst.push_back(n1);
+    }
+  }
 }
 
@@ -372,5 +565,5 @@
 if (!ok)  return;
 if (nobj.length()<1)  nobj = servnobjm->FileName2Name(flnm);
-AddObj(obj->DataObj(), nobj);
+AddObj(obj->DataObj(), nobj, true);
 return;
 }
@@ -416,5 +609,5 @@
     ok = false; 
   } ENDTRY;
-  if (ok)  AddObj(obj->DataObj(), nom);  
+  if (ok)  AddObj(obj->DataObj(), nom, true);  
 }
 
@@ -475,13 +668,46 @@
 static int key_for_write = 5000;
 /* --Methode-- */
-void NamedObjMgr::SaveObj(string & nom, POutPersist& s)
-{
+void NamedObjMgr::SaveObj(string & nom, POutPersist& s, bool keeppath)
+{
+if (nom.length() < 1) return;
+string nob,rep;
+ParseObjectName(nom, rep, nob);
+nom = '/' + rep + '/' + nob;
 NObjMgrAdapter* obja=NULL;
+string nomf = (keeppath) ? nom : nob;
 obja = GetObjAdapter(nom);
 if (obja == NULL)  return;
 printf("NamedObjMgr::SaveObj(%s, )  (Type=%s) \n",  
        nom.c_str(), typeid(*(obja->GetDataObj())).name());
-obja->SavePPF(s, nom);
+obja->SavePPF(s, nomf);
 return; 
+}
+
+/* --Methode-- */
+void NamedObjMgr::SaveObjects(string & patt, string const& flnm)
+{
+string n1,r1;
+if (patt.length() < 1)  return;
+bool keeppath = (patt[0] == '/') ? true : false;
+ParseObjectName(patt, r1, n1);
+patt = '/' + r1 + '/' + n1;
+
+bool ok = true;
+POutPersist* pout;
+TRY{
+  pout = new POutPersist(flnm);
+}  CATCH(merr) 
+  { printf("NamedObjMgr::SaveObjects()/Error Exception= %ld (%s) \n", 
+    (long)merr, PeidaExc(merr));  ok = false; } ENDTRY;
+if (!ok)  return;
+NObjList::iterator it;
+string cn; 
+for(it = myObjs->begin(); it != myObjs->end(); it++) {
+  cn = (*it).first;
+  if (csh_parse(cn.c_str(), patt.c_str()) == 0)  continue;
+  SaveObj(cn, (*pout), keeppath);
+  }
+delete pout;
+return;
 }
 
@@ -502,5 +728,5 @@
 for(it = myObjs->begin(); it != myObjs->end(); it++) {
   no = (*it).first;
-  SaveObj(no, (*pout));
+  SaveObj(no, (*pout), true);
   }
 delete pout;
@@ -651,5 +877,5 @@
 /* --Methode-- */
 void NamedObjMgr::DisplayNT(string& nom, string& nmx, string& nmy, string& nmz,
-                            string& erx, string& ery, string& erz, string dopt)
+                            string& erx, string& ery, string& erz, string dopt, bool fg3d)
 {
 AnyDataObj* obj=GetObj(nom);
@@ -673,5 +899,5 @@
 int opt = servnobjm->DecodeDispOption(dopt, fgsr);
 
-if (nmz.length()>0)  { // Display 3D
+if ( fg3d && (nmz.length()>0) )  { // Display 3D
   PINTuple3D* pin = new PINTuple3D(nt, false);
   pin->SelectXYZ(nmx.c_str(), nmy.c_str(), nmz.c_str());
@@ -684,5 +910,6 @@
   pin->SelectXY(nmx.c_str(), nmy.c_str());
   pin->SelectErrBar(erx.c_str(), ery.c_str());
-  string titre = nmy + "%" + nmz;
+  if ( nmz.length()>0 ) pin->SelectWt(nmz.c_str());
+  string titre = nmy + "%" + nmx;
   wrsid = myImgApp->DispScDrawer( (PIDrawer*)pin, nom, opt, titre);
   }
@@ -776,4 +1003,5 @@
 servnobjm->DecodeDispOption(gratt, fg);
 }
+
 /* --Methode-- */
 void NamedObjMgr::SetGraphicWinZone(int nzx, int nzy, bool fcr)
